
// Demo-Programm: C++-Blockbefehle

#include <iostream.h>
    // enthlt Definitionen der Eingabefunktion cin und der
    // Ausgabefunktion cout

// Faktoriellen-Berechnung, Version 1

int faktorielle1 (unsigned n)
{
    int nfak;

    for (nfak = 1; n > 1; n--)
        nfak *= n;      // nfak = nfak * n;

    return nfak;
}

// Faktoriellen-Berechnung, Version 2

int faktorielle2 (unsigned n)
{
    int nfak = 1;

    while (n > 1)
    {
        nfak *= n;
        n--;
    }
}


// Hauptprogramm:

int main ()
{
    int i;

    for ( ; ; )         // fhre die Befehle in " { }" ad infinitum aus
    {
        cout << "Eingabe (Abbruch mit negativer Zahl):  ";
        cin >> i;

        if (i < 0)      // Test auf Abbruch
            break;      // Abbruch, wenn i < 0

        // rufe die beiden Funktionen zur Faktoriellenberechnung auf

        int j = faktorielle1 (i);
        int k = faktorielle2 (i);

        cout << i << "! = " << j << " (Algorithmus 1), " << k 
            << " (Algorithmus 2)\n";
    }
}
