
// Demo-Programm: Zeiger auf ein Element einer Klasse

#include <iostream.h>   // fr cout

class AClass
{
public:
    int Wert;
    void Anzeigen ()
        {cout << Wert << "\n";}
};

 
// Abgeleitete Type pDAT, die auf Elemente "Wert" der Klasse AClass
// zeigt:

int AClass::*pDAT = & AClass::Wert;

int main ()
{
    AClass A;                   // Objekte Klasse "AClass"
    AClass B;
    AClass *pA = &A;            // Zeiger auf "A"
    AClass *pB = &B;            // Zeiger auf "B"

    A.*pDAT = 1234;             // Zuweisung, de facto auf A.Wert
    B.*pDAT = 2345;

    A.Anzeigen ();              // A.Wert ausgeben
    B.Anzeigen ();              // B.Wert ausgeben

    pA->*pDAT = 4321;           // Dereferenzieren des Zeigers auf A
    pB->*pDAT = 5432;

    pA->Anzeigen ();            // Zeiger
    A.Anzeigen ();              // Objekt
    pB->Anzeigen ();            // Zeiger
    B.Anzeigen ();              // Objekt
}
