
// Demo-Programm: Initialisierung von Klassen-Objekten mit einem
//                Kopier-Konstruktor

#include <iostream.h>

class Konto
{
public:
    Konto ()            // Default-Konstruktor (#1):
        { Stand = 0; }

    Konto (const double& s)             // Kopier-Konstruktor (#2):
        { Stand = s; }

    Konto (double s)                    // Konstruktor #3:
        { Stand = s; };

    Show ()
        { cout << "Kontostand: " << Stand << "\n"; }

private:
    double Stand;
};

Konto k1;                               // Konstruktor #1
Konto k2 = 123.45;                      // Konstruktor #2
Konto k3 (234.56);                      // Konstruktor #3

int main ()
{
        Konto k4;                       // Konstruktor #1
        Konto k5 = 654.32;              // Konstruktor #2
        Konto k6 (765.43);              // Konstruktor #3

        k1.Show (); k2.Show (); k3.Show ();
        k4.Show (); k5.Show (); k6.Show ();
}
