
// Demo-Programm: Statische Datenelemente in einer Klasse

class Punkt
{
public:
    Punkt ()                    // Konstruktor
        { PunkteZahl++; }
    ~Punkt ()                   // Destruktor
        { PunkteZahl--; }

    static int PunkteZahl;
};

 
// Definition von Punkt::PunkteZahl:
int Punkt::PunkteZahl = 0;

#include <iostream.h>

int main ()
{
    cout << "Anzahl der Punkte: " << Punkt::PunkteZahl << "\n";
        // "Punkt::PunkteZahl", weil statisches Objekt, und noch kein
        // Objekt der Klasse Punkt vorhanden

    Punkt p1;                       // p1 ist ein neues Objekt
    cout << "Anzahl der Punkte: " << p1.PunkteZahl << "\n";
        // Alternativ: "p1." statt "Punkt::"

    Punkt *p2 = new Punkt;          // p2 ist ein Zeiger auf ein Objekt

        // die folgenden drei Ausgaben sind identisch:

    cout << "Anzahl der Punkte: " << p2->PunkteZahl << "\n";
    cout << "Anzahl der Punkte: " << p1.PunkteZahl << "\n";
    cout << "Anzahl der Punkte: " << Punkt::PunkteZahl << "\n";

    delete p2;                      // ruft Destruktor auf

    cout << "Anzahl der Punkte: " << Punkt::PunkteZahl << "\n";
}
