
// Demo-Programm: Virtuelle und nicht-virtuelle Funktionen

#include <iostream.h>

class Basis                             // Basisklasse
{
public:
    virtual void Name ()                // virtuell
        { cout << "Basis::Name()\n"; }

    void Aufruf ()                      // nicht-virtuell
        { cout << "Basis::Aufruf()\n"; }
};

class Abgeleitet : public Basis         // abgeleitete Klasse
{
public:
    void Name ()                        // virtuell
        { cout << "Abgeleitet::Name()\n"; }

    void Aufruf ()                      // nicht-virtuell
        { cout << "Abgeleitet::Aufruf()\n"; }
};

int main ()
{
    // Objekt der Klasse Abgeleitet
    Abgeleitet oAbgeleitet;

    // Zeiger
    Abgeleitet *poAbgeleitet = & oAbgeleitet;

    // Funktionsaufrufe:

    cout << "Objekte:\n";
    oAbgeleitet.Name();
    oAbgeleitet.Aufruf();
    oAbgeleitet.Basis::Name();
    oAbgeleitet.Basis::Aufruf();

    cout << "Zeiger vom Typ Abgeleitet:\n";
    poAbgeleitet->Name();
    poAbgeleitet->Aufruf();
    poAbgeleitet->Basis::Name();
    poAbgeleitet->Basis::Aufruf();
};
