
// Demo-Programm: Zugriffs-Typen bei abgeleiteten Klassen - Version 2

class Basis
{
public:
    int Publ_Element() { return 3; }
protected:
    int Prot_Element() { return 5; }
private:
    int Priv_Element() { return 7; }
};

class Publ_Abl : public Basis
{
    int i, j, k;
public:
    Publ_Abl_Func ()
    {
        i = Publ_Element();
        j = Prot_Element();
//      k = Priv_Element();             unzulssig
    }
};

 
class Prot_Abl : protected Basis
{
    int i, j, k;
public:
    Prot_Abl_Func()
    {
        i = Publ_Element();
        j = Prot_Element();
//      k = Priv_Element();             unzulssig
    }
};

class Priv_Abl : private Basis
{
    int i, j, k;
public:
    Priv_Abl_Func()
    {
        i = Publ_Element();
        j = Prot_Element();
//      k = Priv_Element();             unzulssig
    }
};

class Publ_Abl_Abl : public Publ_Abl
{
    int i, j, k;
public:
    Publ_Abl_Abl_Func()
    {
        Publ_Abl_Func();
        i = Publ_Element();
        j = Prot_Element();
//      k = Priv_Element();             unzulssig
    }
};

 
class Prot_Abl_Abl : protected Prot_Abl
{
    int i, j, k;
public:
    Prot_Abl_Abl_Func()
    {
        Prot_Abl_Func();
        i = Publ_Element();
        j = Prot_Element();
//      k = Priv_Element();             unzulssig
    }
};

class Priv_Abl_Abl : private Priv_Abl
{
    int i, j, k;
public:
    Priv_Abl_Abl_Func()
    {
        Priv_Abl_Func();
//      i = Publ_Element();             unzulssig
//      j = Prot_Element();             unzulssig
//      k = Priv_Element();             unzulssig
    }
};


int main ()
{
    // Objekte abgeleiteter Klassen:
    Publ_Abl Publ;    
    Prot_Abl Prot;    
    Priv_Abl Priv;
    Publ_Abl_Abl PublA;    
    Prot_Abl_Abl ProtA;    
    Priv_Abl_Abl PrivA;

    // Funktionsaufrufe:
    Publ.Publ_Abl_Func();
    Prot.Prot_Abl_Func();
    Priv.Priv_Abl_Func();

    PublA.Publ_Abl_Func();
    ProtA.Prot_Abl_Func();
    PrivA.Priv_Abl_Func();

    PublA.Publ_Abl_Abl_Func();
    ProtA.Prot_Abl_Abl_Func();
    PrivA.Priv_Abl_Abl_Func();

    // Zugriffe auf Elemente der Basisklasse
    int i1 = Publ.Publ_Element();
//  int j1 = Publ.Prot_Element();       unzulssig
//  int k1 = Publ.Priv_Element();       unzulssig

    int i2 = Prot.Publ_Element();
//  int j2 = Prot.Prot_Element();       unzulssig
//  int k2 = Prot.Priv_Element();       unzulssig

    int i3 = Priv.Publ_Element();
//  int j3 = Priv.Prot_Element();       unzulssig
//  int k3 = Priv.Priv_Element();       unzulssig

    int i4 = PublA.Publ_Element();
//  int j4 = PublA.Prot_Element();      unzulssig
//  int k4 = PublA.Priv_Element();      unzulssig

//  int i5 = ProtA.Publ_Element();      unzulssig
//  int j5 = ProtA.Prot_Element();      unzulssig
//  int k5 = ProtA.Priv_Element();      unzulssig

//  int i6 = PrivA.Publ_Element();      unzulssig
//  int j6 = PrivA.Prot_Element();      unzulssig
//  int k6 = PrivA.Priv_Element();      unzulssig
}
