
// Demo-Programm: Klassenelement-Funktionen und Klassen als friend

class A;        // Vorwrts-Deklaration

// Deklaration ohne Definition der Funktionen

class B
{
public:
    int Func1(A);
    int Func2(A);
};

class A
{
private:
    int _a;
    friend int B::Func1(A a);
    friend class C;
};

// Definition der Funktionen in Klasse B

int B::Func1(A a)
{
    return a._a;
        // Ok: Func1 ist friend von A
}

int B::Func2(A a) 
{
    return a._a; 
        // unzulssig: Func2 ist nicht friend
}

class C
{
public:
    int Func3(A a) { return a._a; }
        // Ok: Klasse C ist friend von A
};

 
class D : public C
{
public:
    int Func4(A a) { return a._a; }
        // unzulssig: Freundschaften knnen nicht vererbt werden
};
