

// Demo-Programm: Vererbung von Freundschaften und Freunde von Freunden

class A_0               // Basisklasse, Familie "A"
{
protected:
    int a_0;
};

class A_1 : public A_0  // abgeleitet (1. Generation)
{
protected:
    int a_1;

friend class B_1;
};

class A_2 : public A_1  // abgeleitet (2. Generation)
{
protected:
    int a_2;
};

class B_0               // Basisklasse, Familie "B"
{
public:
    int b_00 (A_0 x) { return x.a_0; }  // unzulssig
    int b_01 (A_1 x) { return x.a_1; }  // unzulssig
    int b_02 (A_2 x) { return x.a_2; }  // unzulssig
};

class B_1 : public B_0  // abgeleitet (1. Generation)
{
public:
    int b_10 (A_0 x) { return x.a_0; }  // unzulssig
    int b_11 (A_1 x) { return x.a_1; }
        // einzig zulssiger Zugriff

    int b_12 (A_2 x) { return x.a_2; }  // unzulssig


friend class C;
};

class B_2 : public B_1  // abgeleitet (2. Generation)
{
public:
    int b_20 (A_0 x) { return x.a_0; }  // unzulssig
    int b_21 (A_1 x) { return x.a_1; }  // unzulssig
    int b_22 (A_2 x) { return x.a_2; }  // unzulssig
};

 
class C                 // "Freund des Freundes" von A
{
public:
    int c_00 (A_0 x) { return x.a_0; }  // unzulssig
    int c_01 (A_1 x) { return x.a_1; }  // unzulssig
    int c_02 (A_2 x) { return x.a_2; }  // unzulssig
};
