
// Demo-Programm: Schablone fr eine Klasse

#include <iostream.h>

template <class T> class stack          // allgemeine Klasse "stack"
{
    T *basis;
    T *zeiger;
    int gr;

public:
    stack (int groesse)                 // Konstruktor
    { 
        basis = zeiger = new T [gr = groesse];
    }

    ~stack ()                           // Destruktor
    { 
        delete [] basis; 
    }

    void push (T t)                     // Objekt auf den Stack schieben
    { 
        if (zeiger - basis < gr)        // berlaufschutz
            *zeiger++ = t;
    }

    T pop (void)                        // Objekt vom Stack holen
    {
        if (zeiger > basis)             // berlaufschutz
            return *--zeiger;

        else
            return 0;
    }

    int frei (void)                     // freie Stack-Eintragungen    
    {
        return gr - (zeiger - basis);
    }
};

int main ()
{
    int stackgr;

    cout << "Stack-Gre:  ";
    cin >> stackgr;

    stack <int> si (stackgr);   // Implementierung: Stack fr ints
    stack <char> sc (stackgr);  // Implementierung: Stack fr chars

    // int-Stack auffllen
    do
    {
        int i;

        cout << "Zahl eingeben: ";
        cin >> i;

        si.push (i);    // Elementfunktion mit int-Argument aufgerufen

        cout << "Noch frei: " << si.frei() << " int-Pltze\n";
    }
    while (si.frei () > 0);

    cout << "\n";

    // char-Stack auffllen
    do
    {
        char ch;

        cout << "Zeichen eingeben: ";
        cin >> ch;

        sc.push (ch);   // Elementfunktion mit char-Argument aufgerufen

        cout << "Noch frei: " << sc.frei() << " char-Pltze\n";
    }
    while (sc.frei () > 0);

    // Stacks ausrumen

    cout << "Stacks ausleeren:\n";

    for (int i = 0; i < stackgr; i++)
        cout << "int = " << si.pop() << "; char = " << sc.pop() << "\n";
}