
// Demo-Programm: Mehrdeutigkeit bei Verwendung von Konversionsfunktionen
//                und benutzerdefinierten Operatoren

#include <string.h>

class String
{
public:
    String (char *s) { strcpy (str, s); }
        // Konversions-Konstruktor char* -> String

    operator char*() { return str; }
        // Konversions-Funktion String -> char *

    int operator == (const String s)
        { return ! strcmp (str, s.str); }
        // benutzerdefinierter Gleichheits-Operator

private:
        char str[80];
};


int main ()
{
    String s ("abcde");
    char *pc = "efgh";
    int i;

    i = (s == pc); 
        // mehrdeutig! (in GNU C++ aber zulssig)

    i = ((char*) s == pc);
        // String -> char*, ADRESSEN werden verglichen

    i = (s == String (pc));
        // char* -> String, benutzerdefinierter Vergleich
}
