
// Demo-Programm: Benutzerdefinierte Inkrement- und Dekrement-Operatoren
//                Version 1: Klassenelement-Funktionen

#include <iostream.h>

class Punkt
{
public:
    // Deklaration der Inkrement-Operatoren

    Punkt& operator++();        // Prfix
    Punkt operator++(int);      // Postfix

    // Definition der Dekrement-Operatoren

    Punkt& operator--()         // Prfix
    {
        _x--;                   // Standard-Dekrement
        _y--;
        return *this;
    }

    Punkt operator--(int)       // Postfix
    {
        Punkt temp = *this;     // temporre Variable
        --*this;                // ruft (Prfix-)operator--() auf
        return temp;
    }

    // (Default-) Konstruktor

    Punkt (const short& x = 0, const short& y = 0)
        { _x = x; _y = y; }

    // Zugriff

    Zeige(char *s)
        { cout << s << ": x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
};

// Definition der Inkrement-Operatoren

Punkt& Punkt::operator++()      // Prfix
{
    _x++;                       // Standard-Inkrement
    _y++;
    return *this;
}

Punkt Punkt::operator++(int)    // Postfix
{
    Punkt temp = *this;         // temporre Variable
    ++*this;                    // ruft (Prfix-)operator++() auf
    return temp;
}

int main ()
{
    Punkt p1 (3, 5);

    p1.Zeige("p1");
    ++p1;                       // Prfix-Inkrement
    p1.Zeige("p1");

    Punkt p2 = p1++;            // Postfix-Inkrement

    p1.Zeige("p1");
    p2.Zeige("p2");

    --p1;                       // Prfix-Dekrement
    p1.Zeige("p1");
    p2 = p1--;                  // Postfix-Dekrement

    p1.Zeige("p1");
    p2.Zeige("p2");
}
