
// Demo-Programm: Benutzerdefinierter Zuweisungs-Operator

#include <iostream.h>

class Point
{
public:
    // Standard- und Default-Konstruktor:

    Point (int x = 0, int y = 0)
        { _x = x; _y = y; }

    // Zuweisungs-Operator:

    Point& operator=(const Point& pt)
    {
        _x = 3*pt._x;
        _y = 5*pt._y;
        return *this;
    }

    // Ausgabe-Funktion:

    show ()
        { cout << "x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
};

int main ()
{
    Point pt1 (10, 20);
    Point pt2, pt3;

    pt1.show();
    pt2.show();
    pt3.show();

    pt3 = pt2 = pt1;     // mehrfache benutzerdefinierte Zuweisung

    pt1.show();
    pt2.show();
    pt3.show();
}
