
// Demo-Programm: Operator Overloading fr den Feldindex-Operator "[ ]"

#include <iostream.h>

class IntVektor
{
public:
    int& operator[](int iIndex)
    {
        static int iFehler = 0;         // "Schutz"-Variable

        if (iIndex >= 0 && iIndex < _iG)
            return _iE [iIndex];

        else                            // berlauf
        {
            cout << "Feldueberlauf Element [" << iIndex << "] !\n";
            return iFehler;
        }
    }

    IntVektor (int nElem = 1)           // Konstruktor
    {
        _iE = new int [nElem];          // Feld allokieren
        _iG = nElem;                    // Feldgre
    }

    ~IntVektor()                        // Destruktor
        { delete[] _iE; }

private:
    int *_iE;                           // Zeiger auf Feldelemente
    int _iG;                            // Feldgre
};

int main()
{
    IntVektor v (10);                   // Vektor mit 10 Elementen

    for (int i = -1; i <= 10; i++)
        v[i] = i;                       // initialisiere Feld

    v[2] = v[7];                        // teste Zuweisung

    cout << "Lesen ...\n";

    for (i = -1; i <= 10; i++)          // Ausgabe
        cout << "Element v[" << i << "] = " << v[i] << "\n";
}
