
// Demo-Programm: Deklaration und Definition einer Funktion

#include <iostream.h>           // fr cout und cin

// Deklaration; erforderlich, wenn auf die Funktion vor ihrer Definition 
// zugegriffen werden soll:

double Power (double Arg, unsigned Exp);
    // Funktions-Prototyp; die Namen der Parameter knnen auch
    // weggelassen werden:
    // double Power (double, unsigned);

int main ()
{
    double x = 0;
        // mu hier deklariert werden, weil es auerhalb des folgenden
        // Blocks (in "while ...") bentigt wird

    do
    {
        int exp;
            // kann auch innerhalb der Schleife deklariert werden

        cout << "\nx = ";       // Ausgabe
        cin >> x;               // Eingabe
        cout << "Exp = ";
        cin >> exp;

        cout << x << "^" << exp << " = " << Power (x, exp) << "\n";
    }
    while (x != 0.);
}

// Definition von Power:

double Power (double Arg, unsigned Exp)
{
    double Resultat;

    for (Resultat = 1.; Exp > 0; Exp--)
        Resultat *= Arg; // Resultat = Resultat * Arg;

    return Resultat;
}
