
// Demo-Programm: Einfhrung in C++-Klassen - alternative Deklaration

#include <iostream.h>

class Konto                             // Klassenname "Konto"
{
public:
    // Hier nur DEKLARATIONEN der Klassenelement-Funktionen

    Konto ();                           // Konstruktor
                                        
    void Einlage (double Betrag);       // Zugriffsfunktion
    void Abhebung (double);             // Zugriffsfunktion
    double Stand ();                    // Zugriffsfunktion

private:
    double Kontostand;                  // nicht direkt zugnglich
};

// Separate DEFINITIONEN der Klassenelement-Funktionen

Konto::Konto ()                         // Konstruktor
{
    Kontostand = 0.;
}

void Konto::Einlage (double Betrag)     // Zugriffsfunktion
{
    Kontostand += Betrag;
}

void Konto::Abhebung (double Betrag)    // Zugriffsfunktion
{
    Kontostand -= Betrag;
}

double Konto::Stand ()                  // Zugriffsfunktion
{
    return Kontostand;
}


int main ()
{
    Konto Sparbuch;
        // Definition des Objekts "Sparbuch" der Klasse "Konto"

        // Mit der Definition eines Objekts einer Klasse wird die
        // Konstruktor-Funktion aufgerufen, die in diesem Fall den
        // Kontostand auf 0 setzt.

    cout << "Saldo: " << Sparbuch.Stand() << "\n";      // gibt "0" aus

    Sparbuch.Einlage (500.);
    Sparbuch.Abhebung (200.);

    cout << "Saldo: " << Sparbuch.Stand() << "\n";      // gibt "300" aus
}
