
// Demo-Programm: Initialisierung von Klassen-Objekten mit Konstruktoren
// bersetzungseinheit A: 

#include <iostream.h>

class Point
{
public:
    Point ()                            // Default-Konstruktor (#1):
        { _x = 13; _y = 17; }

    Point (const Point& pt)             // Kopier-Konstruktor (#2):
        { _x = 2*pt._x; _y = 2*pt._y; }

    Point (short x, short y)            // Konstruktor #3:
        { _x = x; _y = y; };

    Show ()
        { cout << "x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
};

void func ();   
        // Vorwrts-Deklaration

extern Point pt1;               // HIER wird kein Konstruktor aufgerufen
Point pt2;                      // Konstruktor #1
Point pt3 (3, 5);               // Konstruktor #3

int main ()
{
    Point pt4;                  // Konstruktor #1
    Point pt5 (7, 11);          // Konstruktor #3

    pt1.Show ();
    pt2.Show ();
    pt3.Show ();
    pt4.Show ();
    pt5.Show ();

    pt4 = pt3;                  // bitweise Kopie, KEIN Konstruktor
    Point pt6 = pt3;            // Konstruktor #2

    pt4.Show ();
    pt6.Show ();

    func ();
}
