
// Demo-Programm: Initialisierung von Klassen-Objekten mit Konstruktoren
// bersetzungseinheit B:

#include <iostream.h>

class Point
{
public:
    Point ()                            // Default-Konstruktor (#1):
        { _x = 13; _y = 17; }

    Point (const Point& pt)             // Kopier-Konstruktor (#2):
        { _x = 2*pt._x; _y = 2*pt._y; }

    Point (short x, short y)            // Konstruktor #3:
        { _x = x; _y = y; };

    Show ()
        { cout << "x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
};

Point pt1 (23, 29);             // Konstruktor #3
Point pt2 (31, 37);             // Konstruktor #3

void func (void)
{
    cout << "*****************\n";
    pt1.Show ();
    pt2.Show ();
}
