
// Demo-Programm: new und delete

#include <iostream.h>

int main ()
{
    int *pi1 = new int (3);                     // einfaches Objekt
    double *pd1 = new double [5];               // Feld von 5 doubles

    *pd1 = 1.1;                                 // Initialisierung
    *(pd1 + 1) = 2.2;
    *(pd1 + 2) = 3.3;
    *(pd1 + 3) = 4.4;
    *(pd1 + 4) = 5.5;

    cout << "pi1 = " << *pi1 << "\n";

    for (int i = 0; i < 5; i++)
        cout << "pd1[" << i << "] = " << pd1[i] << "\n";

    delete pi1;                                 // *pi1 zerstren
    delete [] pd1;                              // Feld zerstren

    // Free Store-Speicher wird "recycled":

    int *pi2 = new int (17);
    double *pd2 = new double [5];

    *pd2 = 11.1;
    *(pd2 + 1) = 22.2;
    *(pd2 + 2) = 33.3;
    *(pd2 + 3) = 44.4;
    *(pd2 + 4) = 55.5;

    // das Folgende ist eigentlich unzulssig:

    cout << "pi1 = " << *pi1 << "\n";

    for (i = 0; i < 5; i++)
        cout << "pd1[" << i << "] = " << pd1[i] << "\n";
}
