
// Demo-Programm: "while"-Schleifen

#include <stdio.h>                   // Standard-C-I/O

const char *strip (const char *buffer);
void write (const char *buffer);

int main ()
{
    char buffer[256];                // Eingabe-Buffer

    printf ("Bitte String eingeben: ");
    gets (buffer);                   // String wird eingelesen

    write (buffer);                  // Ausgabe des Original-Strings
    write (strip (buffer));          // fhrende Leerzeichen "gestrippt"
}
 
const char *strip (const char *buffer)
{
    const char *ptr = buffer;

    while (ptr && *ptr && *ptr <= ' ')
        ptr++;
            // Prfe, ob buffer kein Null-Zeiger  ist (ptr != 0), ob das
            // abschlieende Null-Byte noch nicht erreicht wurde
            // (*ptr != 0), und ob es sich um ein Zeichen mit einem
            // ASCII-Wert <= 0x20 handelt. Wenn ja, teste das nchste
            // Zeichen.

    return ptr;
}

void write (const char *buffer)
{
    printf ("\n***%s***\n", buffer);  // String mit "***" "eingeklammert"
}
