
// Demo-Programm: Bitfelder
//                Equipment List des PC

typedef unsigned short WORD;
    // typedef als Abkrzung in der Definition

struct EquipList
{
    WORD FloppyPresent   : 1;
    WORD NPUPresent      : 1;
    WORD                 : 2;   // reserviert fr Gre des XT-RAM
    WORD ActiveVideoMode : 2;
    WORD FloppyCount     : 2;
    WORD DMAPresent      : 1;
    WORD COMPortCount    : 3;
    WORD GamePortPresent : 1;
    WORD                 : 1;   // reserviert fr PCJr
    WORD LPTPortCount    : 2;
};
 
#include <iostream.h>

extern "C" int biosequip(void); // Bibliotheksfunktion fr Equipment List


int main ()
{
    int i = biosequip ();

    EquipList Equip = *(EquipList *) &i;
        // type cast, um das Ergebnis der Funktion biosequip() (int) auf
        // das Objekt Equip der Type EquipList abzubilden

    if (Equip.FloppyPresent)
        cout << (Equip.FloppyCount + 1);

    else
        cout << "Keine";

    cout << " Diskettenlaufwerk(e)\n";

    if (Equip.NPUPresent)
        cout << "Numerik-Prozessor vorhanden\n";

    cout << Equip.COMPortCount << " Serielle Schnittstelle(n)\n";

    cout << Equip.LPTPortCount << " Druckerschnittstelle(n)\n";

    cout << "Video-Mode: ";

    switch (Equip.ActiveVideoMode)
    {
        case 1:
            cout << "40 Spalten CGA\n";
            break;

        case 2:
            cout << "80 Spalten CGA\n";
            break;

        case 3:
            cout << "80 Spalten Monochrom\n";
            break;

        default:
            cout << "???";
    }
};
