
// Demo-Programm: Einfache Vererbung - Version 2:

#include <iostream.h>
#include <string.h>

class Dokument
{
public:
    char *Name;                         // Name des Dokuments
    void PrintName ()                   // Ausgabefunktion
        { cout << Name << "\n"; }
};

class Buch : public Dokument
{
public:
    Buch (char *name, int seiten);
    void PrintName ();                  // Spezial-Ausgabefunktion
private:
    int Seitenzahl;
};

// Konstruktor:
Buch::Buch (char *name, int seiten)
{
    Name = new char [strlen (name) + 1];
    strcpy (Name, name);
    Seitenzahl = seiten;
}

void Buch::PrintName ()
{
    cout << "Titel:  " << Name << "\nSeiten: " << Seitenzahl << "\n";
}

int main ()
{
    Buch Stroustrup ("The C++ Programming "
        "Language, 2nd Ed", 669);

    Stroustrup.PrintName ();

    Stroustrup.Dokument::PrintName ();
}
