
// Demo-Programm: Virtuelle und nicht-virtuelle Funktionen

#include <iostream.h>

class Basis                             // Basisklasse
{
public:
    virtual void Name ()                // virtuell
        { cout << "Basis::Name()\n"; }

    void Aufruf ()                      // nicht-virtuell
        { cout << "Basis::Aufruf()\n"; }
};

class Abgeleitet : public Basis         // abgeleitete Klasse
{
public:
    void Name ()                        // virtuell
        { cout << "Abgeleitet::Name()\n"; }

    void Aufruf ()                      // nicht-virtuell
        { cout << "Abgeleitet::Aufruf()\n"; }
};

int main ()
{
    // Objekte von Basis und Abgeleitet
    Basis oBasis;
    Abgeleitet oAbgeleitet;

    // Zeiger
    Basis *poBasis1 = & oBasis;
    Basis *poBasis2 = & oAbgeleitet;
    Abgeleitet *poAbgeleitet = & oAbgeleitet;

    // Funktionsaufrufe:

    cout << "Objekte:\n";
    oBasis.Name();
    oBasis.Aufruf();
    oAbgeleitet.Name();
    oAbgeleitet.Aufruf();

    cout << "Zeiger vom Typ Basis:\n";
    poBasis1->Name();
    poBasis1->Aufruf();
    poBasis2->Name();
    poBasis2->Aufruf();

    cout << "Zeiger vom Typ Abgeleitet:\n";
    poAbgeleitet->Name();
    poAbgeleitet->Aufruf();
};
