
// Demo-Programm: Schablone fr eine Klasse - alternative Definition

#include <iostream.h>

template <class T> class stack
{
    T *basis;
    T *zeiger;
    int gr;

public:
    stack (int);                        // Konstruktor
    ~stack ();                          // Destruktor
    void push (T);
    T pop (void);
    int frei (void);
};

template <class T> stack <T>::stack (int groesse)
{ 
    basis = zeiger = new T [gr = groesse];
}

template <class T> stack <T>::~stack ()
{ 
    delete [] basis; 
}

template <class T> void stack <T>::push (T t)
{ 
    if (zeiger - basis < gr)
        *zeiger++ = t;
}

template <class T> T stack <T>::pop (void)
{
    if (zeiger > basis)
        return *--zeiger;
    else
        return 0;
}

template <class T> int stack <T>::frei (void)
{
    return gr - (zeiger - basis);
}

int main ()
{
    int stackgr;

    cout << "Stack-Gre:  ";
    cin >> stackgr;

    stack <int> si (stackgr);   // Implementierung: Stack fr ints
    stack <char> sc (stackgr);  // Implementierung: Stack fr chars

    // int-Stack auffllen
    do
    {
        int i;

        cout << "Zahl eingeben: ";
        cin >> i;

        si.push (i);    // Elementfunktion mit int-Argument aufgerufen

        cout << "Noch frei: " << si.frei() << " int-Pltze\n";
    }
    while (si.frei () > 0);

    cout << "\n";

    // char-Stack auffllen
    do
    {
        char ch;

        cout << "Zeichen eingeben: ";
        cin >> ch;

        sc.push (ch);   // Elementfunktion mit char-Argument aufgerufen

        cout << "Noch frei: " << sc.frei() << " char-Pltze\n";
    }
    while (sc.frei () > 0);

    // Stacks ausrumen

    cout << "Stacks ausleeren:\n";

    for (int i = 0; i < stackgr; i++)
        cout << "int = " << si.pop() << "; char = " << sc.pop() << "\n";
}