
// Demo-Programm: Kopier-Konstruktor und benutzerdefinierte Zuweisung

#include <iostream.h>

class Point
{
public:
    Point (int x = 0, int y = 0)     // Standard- und Default-Konstruktor
        { _x = x; _y = y; }

    Point (const Point& pt)          // Kopier-Konstruktor
        { _x = 3*pt._x; _y = 3*pt._y; }

    Point& operator=(const Point& pt) // Zuweisungs-Operator
    {
        _x = 5*pt._x;
        _y = 5*pt._y;
        return *this;
    }

    show ()                          // Ausgabe-Funktion
        { cout << "x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
};

int main ()
{
    Point pt1 (10, 20);         // Standard-Konstruktor
    Point pt2 = pt1;            // Kopier-Konstruktor
    Point pt3;                  // Default-Konstruktor

    pt1.show();
    pt2.show();
    pt3.show();

    pt3 = pt1;                  // benutzerdefinierte Zuweisung

    pt3.show();
}
