
// Demo-Programm: Default-Konstruktor und Zuweisungen zwischen Objekten
//                einer Basisklasse und einer abgeleiteten Klasse

#include <iostream.h>

class Basis
{
public:
    Basis (int i = 0, int j = 0)
        { _i = i; _j = j; }

    Show ()
        { cout << "Basis: i = " << _i << ", j = " << _j << "\n"; }

protected:
    int _i, _j;
};

 
class Abgeleitet : public Basis
{
public:
    Abgeleitet (int i = 0, int j = 0, int k = 0)
        { _i = i; _j = j; _k = k; }

    Show ()
        { cout << "Abgeleitet: i = " << _i << ", j = " << _j << ", k = "
            << _k << "\n"; }

protected:
    int _k;
};

int main ()
{
    Basis b1 (3, 5);
    Abgeleitet a1 (7, 11, 13);

    Basis b2 = a1;                      // Initialisierung
//  Abgeleitet a2 = b1;        unzulssige Initialisierung

    Basis b3;                           // (0, 0)
    Abgeleitet a3;                      // (0, 0, 0)

    b1.Show();
    a1.Show();
    b2.Show();
//  a2.Show();                 Objekt wurde nicht definiert
    b3.Show();
    a3.Show();

    b3 = a1;                            // Zuweisung
//  a3 = b1;                   unzulssige Zuweisung

    b3.Show();
    a3.Show();
}
