
// Demo-Programm: Initialisierung eingeschlossener Klassen-Objekte

#include <iostream.h>

class Point
{
public:
    Point (short x = 0, short y = 0)
        { _x = x; _y = y; }
            // Standard- und Default-Konstruktor

    Show ()
        { cout << "x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
};
 
class Rect
{
public:
    Rect (short x1, short y1, short x2, short y2);      // Deklaration

    Show ()
    {
        cout << "Punkt 1: ";
        _pt1.Show();
        cout << "Punkt 2: ";
        _pt2.Show();
    }

private:
    Point _pt1, _pt2;                   // Objekte von Klasse Point
};

// Definition des Konstruktors von Rect

Rect::Rect (short x1, short y1, short x2, short y2) : 
    _pt1 (x1, y1), _pt2 (x2, y2)
{
}       // LEERE Funktionsdefinition!

int main ()
{
    Rect r (1, 2, 3, 4);

    r.Show();
}
