
// Demo-Programm: Function Overloading mit const und volatile Referenzen
//                als Argument

#include <iostream.h>

class Ol
{ 
public:
    Ol ()
    {
        cout << "Default-Konstruktor fuer Ol\n";
    }

    Ol (Ol& o)
    {
        cout << "Ol&\n";
    }

    Ol (const Ol& o)
    {
        cout << "const Ol&\n";
    }

    Ol (volatile Ol& o)
    {
        cout << "volatile Ol&\n";
    }
};

int main ()
{
    Ol o1;                      // Default-Konstruktor

    Ol o2(o1);                  // Ol(Ol&)

    const Ol o3;                // Default-Konstruktor

    Ol o4(o3);                  // Ol(const Ol&)

    volatile Ol o5;             // Default-Konstruktor

    Ol o6(o5);                  // Ol(volatile Ol&)
}

