
// Demo-Programm: Operator Overloading fr den Elementauswahl-Operator
//                ("->")

#include <iostream.h>

const int magic = 0x12345678;           // "magische" Zahl

class Punkt
{
public:
    Punkt *operator->()
    {
        if (_magic == magic)            // Zeiger ok
            return this;

        else                            // falscher Zeiger
        {
            cout << "Falscher Zeiger!\n";
            return &_ptFehler;
        }
    }

    Punkt (short x = 0, short y = 0)    // Konstruktor
        { _x = x; _y = y; _magic = magic; }

    Zeige ()
        { cout << "x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
    int _magic;                         // Kopie der "magischen" Zahl
    static Punkt _ptFehler;             // Objekt, das im Fehlerfall
                                        // angesprochen werden kann 
};

Punkt Punkt::_ptFehler (3, 5);          // Definition des statischen
                                        // Objekts

int main ()
{
    Punkt pt (11, 13);                  // Objekt
    Punkt *ppt = &pt;                   // Zeiger darauf

    ppt->Zeige();                       // Zugriff ok
                                        // Resultat ist (11, 13)

    ppt++;                              // ppt zeigt irgendwo hin

    ppt->Zeige();                       // Fehler
                                        // Resultat sollte (3, 5) sein
}
