
// Demo-Programm: Benutzerdefinierter operator new()

#include <iostream.h>
#include <malloc.h>             // fr malloc()
#include <memory.h>             // fr memset()

class Obj
{
public:
    Show ()
        { cout << "Objekt = " << hex << _obj << "\n"; }

    void *operator new (size_t n, char Ini)
    {
        void *pTemp = malloc (n);               // allokiere Speicher

        if (pTemp)                              // malloc() war ok
            memset (pTemp, Ini, n);             // initialisiere Speicher

        return pTemp;
    }

private:
    int _obj;
};

int main ()
{
    Obj *po1 = new (0x5a) Obj;                  // Einzel-Objekt
    po1->Show();

    Obj *po2 = new (0x71) Obj [10];             // Feld
    po2[3].Show();
}
