
// Demo-Programm: Konsol-Ausgabe mit iostream-Funktionen

#include <iostream.h>
#include <iomanip.h>                    // fr Manipulatoren

int ai[] = { 3, 17, 123, 4321, 23456 };
double ad[] = { .1234, 43.21, 543.456, 2345.6, 765432.109876 };
char *as[] = { "The", "quick", "brown", "fox", "jumps" };

int main ()
{
    cout << "\nDefault-Formatierung:\n";

    for (int i = 0; i < 5; i++)
        cout << "int: " << ai[i] << ", double: " << ad[i] << ", string: "
            << as[i] << endl;

        // endl == "\n"
 
    cout << "\nKonstante Spaltenbreite:\n";

    for (i = 0; i < 5; i++)
    {
        cout.width (10);        // Spaltenbreite = 10
                                // gilt nur fr das folgende Feld!
        cout << ai[i] << endl;
    }

    for (i = 0; i < 5; i++)
        cout << "int: " << setw(7) << ai[i] << ", double: " << setw(10)
            << ad[i] << ", string: " << setw(7) << as[i] << endl;

        // setw gilt nur fr das folgende Feld!

    cout << "\nSpalte auffllen:\n";

    cout.fill ('*');            // Fllzeichen "*"

    for (i = 0; i < 5; i++)
        cout << "int: " << setw(7) << ai[i] << ", double: " << setw(10)
            << ad[i] << ", string: " << setw(7) << as[i] << endl;

    cout.fill (' ');            // zurck zum Default

    cout << "\nLinksbndige Ausgabe:\n" << setiosflags (ios::left);

    for (i = 0; i < 5; i++)
        cout << "int: " << setw(7) << ai[i] << ", double: " << setw(10)
            << ad[i] << ", string: " << setw(7) << as[i] << endl;

    cout << resetiosflags (ios::left) << "\nAuflsung: 2 Stellen:\n" <<
        setprecision (2);

    for (i = 0; i < 5; i++)
        cout << "int: " << setw(7) << ai[i] << ", double: " << setw(10)
            << ad[i] << ", string: " << setw(7) << as[i] << endl;

    cout << "\nExponentenschreibweise:\n" << 
        setiosflags (ios::scientific);

    for (i = 0; i < 5; i++)
        cout << "int: " << setw(7) << ai[i] << ", double: " << setw(10)
            << ad[i] << ", string: " << setw(7) << as[i] << endl;

    cout << "\nGleitkommaschreibweise:\n" << 
        resetiosflags (ios::scientific) << setiosflags (ios::fixed);

    for (i = 0; i < 5; i++)
        cout << "int: " << setw(7) << ai[i] << ", double: " << setw(10)
            << ad[i] << ", string: " << setw(7) << as[i] << endl;

    cout << "\nRadix:\n" << setprecision (6);

    for (i = 0; i < 5; i++)
        cout << "Dezimal: " << dec << ai[i] << ", oktal: " << oct <<
            ai[i] << ", hex: " << hex << ai[i] << endl;
}
