
// Demo-Programm: Statusabfrage bei Stream-Eingabe-Operationen

#include <iostream.h>

int main ()
{
    int do_clear = 1;           // Flag-Variable - "clear" aktiv
    int do_flush = 1;           // Flag-Variable - Rest einlesen
    char antwort;

    cout << "\"clear\" nach einem Fehler (J/n)?  ";
    cin >> antwort;

    if (antwort == 'n' || antwort == 'N')
        do_clear = 0;

    cout << "Eingabezeile nach einem Fehler ausleeren (J/n)?  ";
    cin >> antwort;

    if (antwort == 'n' || antwort == 'N')
        do_flush = 0;

    for (int i = 0; i < 10; i++)
    {
        int x;

        cout << "Bitte eine ganze Zahl eingeben:  ";
        cin >> x;

        if (cin.good())
            cout << "Status ist \"good\"";

        if (cin.bad())
            cout << "Status ist \"bad\"";

        if (cin.fail())
        {
            cout << "Status ist \"failed\"";

            if (do_clear)
                cin.clear ();

            if (do_flush)
            {
                char buffer[128];
                cin >> buffer;
            }
        }

        cout << " - Eingabe war: " << x << endl;
    }
}
