
// Demo-Programm: Die Prprozessor-Direktive #undef

#include <ctype.h>                      // GNU-C++-Definition

char func1 (char ch)
{
    return toupper(ch);
}

#undef toupper                          // vorige Definition ungltig

// hier darf toupper(c) nicht aufgerufen werden, weil dieser Name hier 
// nicht existiert

#define _toupper(c) ( (c)-'a'+'A' )
#define toupper(c) ( (islower(c)) ? _toupper(c) : (c) )
                                        // "klassische" Definition

char func2 (char ch)
{
    return toupper(ch);
}
