
// Demo-Programm: Bedingte bersetzung
//                bersetzen mit:
//                gcc 7_02_07.cc -Wall -lpp -g -o 7_02_07 -DTEST=x
//                mit x = beliebiger numerischer Wert
//                ACHTUNG: Keine Abstnde zwischen "-D", "TEST", "=" und
//                dem Zahlenwert!


#include <iostream.h>

int main ()
{
#if ! defined (TEST)            // TEST war beim Aufruf nicht definiert

    cout << "Versuchen Sie, das Programm mit\n"
        "\"gcc 7_02_07.cc -Wall -lgpp -g -o 7_02_07 -DTEST\"\n"
        "zu bersetzen!\n";

#else                           // TEST definiert

#if TEST < 0

    cout << "Das Programm wurde mit einem Wert < 0 fr TEST "
        "bersetzt.\n";

#elif TEST > 1

    cout << "Das Programm wurde mit TEST > 1 bersetzt.\n";

#elif TEST == 0

    cout << "Das Programm wurde am " __DATE__ " um " __TIME__ " Uhr "
        "bersetzt.\n";

#else    // definiert, aber ohne Wertzuweisung; entspricht TEST == 1

    cout << "Versuchen Sie jetzt, das Programm mit\n"
        "\"gcc 7_02_07.cc -Wall -lgpp -g -o 7_02_07 -DTEST=0\"\n"
        "und dann mit anderen Werten fr TEST zu bersetzen!\n";

#endif  // Ende von "#if TEST < 1"

#endif  // Ende von "#if ! defined TEST"


#if 0

    cout << "Diese Ausgabe werden Sie nie zu sehen bekommen!\n";

#else
    cout << "\nSie werden diese Zeile immer erhalten!\n";

#endif
}
